/** This is the template for purchasing towers and checking for sufficient funds 
 *  Below will have a few blanks for you to fill in with the correct missing code. Solutions can be found on the website or Github.
**/

// Current amount of money owned by the player
int currentBalance = 750; // Give the user $750 of starting balance
final int rewardPerBalloon = 20; // Money earned by popping a balloon
final color towerErrorColour = #E30707; // Colour to display when user purchases tower without sufficient funds

void handleBalloonPop() {
  // Reward the player for popping the balloon
  increaseBalance(rewardPerBalloon);
}


void increaseBalance(int amount) {
  currentBalance += amount; // Increase the current balance by the amount given
}


/** Checks to see if there is sufficient balance for purchasing a certain item
 *  Parameter "cost" is the cost of the tower to be purchased
 *  Variable  "currentBalance" is already declared and is the user's current balance
 */
boolean hasSufficientFunds(int cost) {
  
  /** ------------ FILL IN MISSING CODE HERE ------------ **/
  
}

/** Purchases a tower (deducts cost from the user's current balance)
 *  Parameter "cost" is the cost of the tower to be purchased
 */
void purchaseTower(int cost) {
  
  /** ------------ FILL IN MISSING CODE HERE ------------ **/
  
}

/** Checks to see if the user is attempting to purchase/pick up a tower but has insufficient funds
 *  Parameter "towerID" is the ID of the tower to check for
 *  Variable  "currentBalance" is already declared and is the user's current balance
 *  Array "towerPrice" is already declared and it contains the prices for each of the towers
 *  Method withinBounds(towerID) returns a boolean stating if the user's pointer is within the pick-up box
 *  Method hasSufficientFunds(cost) returns a boolean stating if the user has sufficient funds to purchase a tower of price "cost"
 */
boolean attemptingToPurchaseTowerWithoutFunds(int towerID) {
  
  /** ------------ FILL IN MISSING CODE HERE ------------ **/
  
}

// Displays the user's current balance on the screen
void drawBalanceDisplay() {
  // If the user is attempting to purchase a tower without funds, warn them with red display text
  boolean error = false;
  for (int i = 0; i < 3; i++) {
    
    /** check to see if the user is attempting to purchase tower "i" without sufficient funds. If so, set "error" to true. **/
    /** ------------ FILL IN MISSING CODE HERE ------------ **/
    
    
  }
  if (error) {
    fill(towerErrorColour); // Warn the user that they are attempting to purchase a tower without sufficient funds
  }
  else {
    fill(0); // Black text
  }
  
  text("Current Balance: $" + currentBalance, 336, 65);
}



/** Disregard this section. Placeholders for methods and variables declared in other files **/
/** -------------------------------------------------------------------------------------- **/
boolean withinBounds(int towerID) { return false; }
int towerPrice[];
/** -------------------------------------------------------------------------------------- **/
